#include <windows.h>

#include "global.h"
#include "resource.h"
#include "stredit.h"

static TCHAR * pParamName;
static TCHAR * pValue;
static TCHAR * pResValue;
static DWORD   nResSize;

//****************************************************************************
BOOL WINAPI _streditDialogHook (HWND h_wndDlg, UINT u_msg, WPARAM w_param, LPARAM l_param)
{
  switch (u_msg)
  {
    case WM_INITDIALOG:
    {
      SetDlgItemText (h_wndDlg, IDC_EDIT_PARAMETR, pParamName); 
      SetDlgItemText (h_wndDlg, IDC_EDIT_VALUE, pValue); 
    }
    return FALSE;

    case WM_COMMAND:
      if (LOWORD(w_param) == IDCANCEL || LOWORD(w_param) == IDOK) 
      {
        if (LOWORD(w_param) == IDOK)
        {
          nResSize = GetWindowTextLength (GetDlgItem(h_wndDlg,IDC_EDIT_VALUE))+1;
          if ((pResValue = (TCHAR*)LocalAlloc (LMEM_FIXED, nResSize*sizeof(TCHAR))) != NULL)
          {
            nResSize = GetDlgItemText (h_wndDlg, IDC_EDIT_VALUE, pResValue, nResSize);
            nResSize = (nResSize + 1) * sizeof(TCHAR);
          }
        }   
        EndDialog (h_wndDlg, LOWORD(w_param));
        return LOWORD(w_param);
      }
    break;
  } 
  return FALSE;
}

//****************************************************************************
DWORD StrEdit_Run (HWND h_parentWnd, TCHAR * p_name, TCHAR * p_value)
{
  DWORD ret;

  pParamName = p_name;
  pValue = p_value;

  if (pResValue != NULL)
  {
    LocalFree ((HLOCAL)(pResValue));
    pResValue = NULL;
  }
  
  ret = DialogBox (hInst, MAKEINTRESOURCE(IDD_DIALOG_EDIT_STRING), h_parentWnd,
                          (DLGPROC)_streditDialogHook);
  return ret;
}

//****************************************************************************
void StrEdit_GetResult (TCHAR **p_result, DWORD * n_resSize)
{
  *p_result  = pResValue;
  *n_resSize = nResSize;
}

